/*
Name:		Regulator.h
Created:	16.11.2018 16:23:57
Author:	Felix Bruchhage und Luca Di Lillo
Version:	1.0.0
*/

#include "Regulator.h"

Regulator::Regulator()
{

}

Regulator::~Regulator()
{

}

/**********************************************
*This initializes the Regulator library.	  *
*The first input argument is for Kp,		  *
*the second argument is for Ki,				  *
*the third argument is for Kd,				  *
*if you need a PID Regulator, set all		  *
*arguments higher than 0, if you need a		  *
*PI regulator, set the Kd argument to zero,   *
*if you need a PD regulator, set Ki to zero.  *
**********************************************/
void Regulator::begin(double Kp, double Ki, double Kd)
{
	KP = Kp;
	KI = Ki;
	KP = Kp;
}
/******************************************
*This function shows the actual direction *
*of the encoder							  *
******************************************/
double Regulator::calculateControlvariable(double sollwert, double istwert)
{
	Zeit = millis();
	Zeitdifferenz = (Zeit - Zeitalt) * 0.001;
	Regeldifferenz = sollwert - istwert;

	Stellgroesse = (KP * Regeldifferenz) + (KI * (Regeldifferenz * Zeitdifferenz)) + (KD * Regeldifferenz / Zeitdifferenz);

	Zeitalt = Zeit;

	return Stellgroesse;
}
